﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SlimDX;
namespace LittleBigTable
{
    class tetrahendra
    {
        
        public Vector3 v0;
        public Vector3 v1;
        public Vector3 v2;
        public Vector3 v3;

        public Vector3 f0;
        public Vector3 f1;
        public Vector3 f2;
        public Vector3 f3;


        public Vector3 prevV0;
        public Vector3 prevV1;
        public Vector3 prevV2;
        public Vector3 prevV3;


        public int idV0;
        public int idV1;
        public int idV2;
        public int idV3;

        public int[] id=new int[4];

        public int PrevIDV0;
        public int PrevIDV1;
        public int PrevIDV2;
        public int PrevIDV3;


        public float[,] ElementStiffnessMatrix=new float[12,12];

        public tetrahendra()
        {
            for (int i = 0; i < 12; i++)
            {
                ElementStiffnessMatrix[i, i] = 1.0f;
            }
            for (int i = 0; i < 9; i++)
            {
                ElementStiffnessMatrix[i, 3 + i] = 0.9f;
            }
            for (int i = 0; i < 6; i++)
            {
                ElementStiffnessMatrix[i, 6 + i] = 0.9f;
            }
            for (int i = 0; i < 3; i++)
            {
                ElementStiffnessMatrix[i, 9 + i] = 0.9f;
            }
            for (int i = 0; i < 9; i++)
            {
                ElementStiffnessMatrix[3 + i, i] = 0.9f;
            }
            for (int i = 0; i < 6; i++)
            {
                ElementStiffnessMatrix[6 + i, i] = 0.9f;
            }
            for (int i = 0; i < 3; i++)
            {
                ElementStiffnessMatrix[9 + i, i] = 0.2f;
            }
        
            
        }
        public void UpdateElementMatrix(List<Vector3> Positions)
        {
             v0=Positions[id[0]];
             v1=Positions[id[1]];
             v2 = Positions[id[2]]; 
             v3 = Positions[id[3]];
             Vector3[] vSum=new Vector3[]{v0,v1,v2,v3};
             //for (int i = 0; i < 4; i++)
             //{
             //    for (int j = i + 1; j < 4; j++)
             //    {
             //        ElementStiffnessMatrix[3 * i, 3 * j] = -(vSum[i] - vSum[j]).X;
             //        ElementStiffnessMatrix[3 * i + 1, 3 * j + 1] = -(vSum[i] - vSum[j]).Y;
             //        ElementStiffnessMatrix[3 * i + 2, 3 * j + 2] = -(vSum[i] - vSum[j]).Z;
             //    }
             //}
             //for (int i = 0; i < 4; i++)
             //{
             //    for (int j = i + 1; j < 4; j++)
             //    {
             //        ElementStiffnessMatrix[3 * j, 3 * i] = (vSum[j] - vSum[i]).X;
             //        ElementStiffnessMatrix[3 * j + 1, 3 * i + 1] = (vSum[j] - vSum[i]).Y;
             //        ElementStiffnessMatrix[3 * j + 2, 3 * i + 2] = (vSum[j] - vSum[i]).Z;
             //    }
             //}
        }
        
        //Here is the four nodes in one tetrahedron
        
    }
    struct MappingFromNodesToT
    {
        public int index;
        public int nodeNum;
        public  MappingFromNodesToT(int idx, int nNm)
        {
            index = idx;
            nodeNum = nNm;
        }
    }
    
    class tetrahendraMesh
    {
        public int XVertices=3;
        public int YVertices=3;
        public int ZVertices=3;
        public int numVertices;
        public Vector3 Interval=new Vector3(10.0f,10.0f,10.0f);
        public List<Vector3> NodesPosition;
        public List<List<MappingFromNodesToT>> Mapping;
        public List<Vector3> PrevNodesPosition;
        public List<tetrahendra> Tetrahendrons;
        Vector3 MinimumXYZ = new Vector3(1000, 1000, 1000);
        Vector3 MaximumXYZ = new Vector3(-1000, -1000, -1000);
        public List<List<int>> C;
        Vector3[] UpdatedPosition;
        public void BuildPosition(ref Vector3[] positions)
        {
            C = new List<List<int>>();
            UpdatedPosition = new Vector3[positions.Length];
            Vector3[] VertexDisplacement = new Vector3[positions.Length]; 
            //Find the minimum of X, Y,Z 
            //Find the maximimu of X, Y, Z 
           
            for (int i = 0; i < positions.Length; i++)
            {
                if (positions[i].X < MinimumXYZ.X)
                {
                    MinimumXYZ.X=positions[i].X;
                }
                if(positions[i].Y < MinimumXYZ.Y)
                {
                    MinimumXYZ.Y=positions[i].Y;
                }
                if (positions[i].Z < MinimumXYZ.Z)
                {
                    MinimumXYZ.Z = positions[i].Z;
                }
            }
            for (int i = 0; i < positions.Length; i++)
            {
                if (positions[i].X > MaximumXYZ.X)
                {
                    MaximumXYZ.X = positions[i].X;
                }
                if (positions[i].Y > MaximumXYZ.Y)
                {
                    MaximumXYZ.Y = positions[i].Y;
                }
                if (positions[i].Z > MaximumXYZ.Z)
                {
                    MaximumXYZ.Z = positions[i].Z;
                }
            }
            for (int i = 0; i < positions.Length; i++)
            {
                UpdatedPosition[i] = positions[i] - MinimumXYZ;
            }
            //Update the Interval
            Interval.X = (MaximumXYZ.X - MinimumXYZ.X) / XVertices;
            Interval.Y = (MaximumXYZ.Y - MinimumXYZ.Y) / YVertices;
            Interval.Z = (MaximumXYZ.Z - MinimumXYZ.Z) / ZVertices;

            BuildMesh();

            //MapVertices Into the Cubics 
            // It is a simple Mapping, which is 
            
           for (int i = 0; i < UpdatedPosition.Length; i++)
            {
                Vector3 minimum = new Vector3(100, 100, 100);
                int index = 0;
                for (int j = 0; j < NodesPosition.Count; j++)
                {
                    if ((UpdatedPosition[i] - NodesPosition[j]).Length() < minimum.Length())
                    {
                        minimum = (UpdatedPosition[i] - NodesPosition[j]);
                        index = j;
                    }
                }
                C[index].Add(i);
               
            }
           
           
        }
        public void UpdatePosition(ref Vector3[] positions, float[] DeltaU)
        {
            // for (int i = 0; i < UpdatedPosition.Length; i++)
            //{
            //    Vector3 minimum=new Vector3(100,100,100);
            //    int index = 0;
            //    for (int j = 0; j < NodesPosition.Count; j++)
            //    {
            //        if ((UpdatedPosition[i] - NodesPosition[j]).Length() < minimum.Length())
            //        {
            //            minimum = (UpdatedPosition[i] - NodesPosition[j]);
            //            index = j;
            //        }
            //    }
              
            //    UpdatedPosition[i].X+= DeltaU[3*index];
            //    UpdatedPosition[i].Y += DeltaU[3 * index+1];
            //    UpdatedPosition[i].Z += DeltaU[3 * index+2];

            //    positions[i].X += DeltaU[3 * index];
            //    positions[i].Y += DeltaU[3 * index + 1];
            //    positions[i].Z += DeltaU[3 * index + 2];
            //}

            //for (int i = 0; i < C.Count; i++)
            //{
            //    C[i].Clear();
            //}


            //for (int i = 0; i < UpdatedPosition.Length; i++)
            //{
            //    Vector3 minimum = new Vector3(100, 100, 100);
            //    int index = 0;
            //    for (int j = 0; j < NodesPosition.Count; j++)
            //    {
            //        if ((UpdatedPosition[i] - NodesPosition[j]).Length() < minimum.Length())
            //        {
            //            minimum = (UpdatedPosition[i] - NodesPosition[j]);
            //            index = j;
            //        }
            //    }
            //    C[index].Add(i);

            //}

            for (int i = 0; i < C.Count; i++)
            {
                for (int j = 0; j < C[i].Count; j++)
                {
                    positions[C[i][j]].X += DeltaU[3 * i] / (UpdatedPosition[C[i][j]] - NodesPosition[i]).Length();
                    positions[C[i][j]].Y += DeltaU[3 * i + 1] / (UpdatedPosition[C[i][j]] - NodesPosition[i]).Length();
                    positions[C[i][j]].Z += DeltaU[3 * i + 2] / (UpdatedPosition[C[i][j]] - NodesPosition[i]).Length();
                    UpdatedPosition[C[i][j]].X += DeltaU[3 * i] / (UpdatedPosition[C[i][j]] - NodesPosition[i]).Length();
                    UpdatedPosition[C[i][j]].Y += DeltaU[3 * i + 1] / (UpdatedPosition[C[i][j]] - NodesPosition[i]).Length();
                    UpdatedPosition[C[i][j]].Z += DeltaU[3 * i + 2] / (UpdatedPosition[C[i][j]] - NodesPosition[i]).Length();
                }

            }
            //for (int i = 0; i < positions.Length; i++)
            //{
            //    for (int j = 0; j < NodesPosition.Count; j++)
            //    {
            //        positions[i].X += DeltaU[3 * j] / (UpdatedPosition[i] - NodesPosition[j]).Length();
            //        positions[i].Y += DeltaU[3 * j + 1] / (UpdatedPosition[i] - NodesPosition[j]).Length();
            //        positions[i].Z += DeltaU[3 * j + 2] / (UpdatedPosition[i] - NodesPosition[j]).Length();

            //        UpdatedPosition[i].X += DeltaU[3 * j] / (UpdatedPosition[i] - NodesPosition[j]).Length();
            //        UpdatedPosition[i].Y += DeltaU[3 * j + 1] / (UpdatedPosition[i] - NodesPosition[j]).Length();
            //        UpdatedPosition[i].Z += DeltaU[3 * j + 2] / (UpdatedPosition[i] - NodesPosition[j]).Length();

            //    }
            //}
            //for (int i = 0; i < positions.Length; i++)
            //{
            //    for (int j = 0; j < NodesPosition.Count; j++)
            //    {
            //        positions[i].X += DeltaU[3 * j] / ((UpdatedPosition[i] - NodesPosition[j]).Length() * (UpdatedPosition[i] - NodesPosition[j]).Length());
            //        positions[i].Y += DeltaU[3 * j + 1] / ((UpdatedPosition[i] - NodesPosition[j]).Length() * (UpdatedPosition[i] - NodesPosition[j]).Length());
            //        positions[i].Z += DeltaU[3 * j + 2] / ((UpdatedPosition[i] - NodesPosition[j]).Length()*(UpdatedPosition[i] - NodesPosition[j]).Length());

            //        UpdatedPosition[i].X += DeltaU[3 * j] / ((UpdatedPosition[i] - NodesPosition[j]).Length() * (UpdatedPosition[i] - NodesPosition[j]).Length());
            //        UpdatedPosition[i].Y += DeltaU[3 * j + 1] / ((UpdatedPosition[i] - NodesPosition[j]).Length() * (UpdatedPosition[i] - NodesPosition[j]).Length());
            //        UpdatedPosition[i].Z += DeltaU[3 * j + 2] / ((UpdatedPosition[i] - NodesPosition[j]).Length() * (UpdatedPosition[i] - NodesPosition[j]).Length());

            //    }
            //}
           


        }
        public void BuildMesh()
        {
            Mapping = new List<List<MappingFromNodesToT>>();
            NodesPosition = new List<Vector3>();
            Tetrahendrons = new List<tetrahendra>();
            numVertices = 0;
            
            for (int i = 0; i < XVertices; i++)
            {
                for (int j = 0; j < YVertices; j++)
                {
                    for (int k = 0; k < ZVertices; k++)
                    {
                        NodesPosition.Add(new Vector3((MaximumXYZ- MinimumXYZ).X/4+ i * Interval.X/2, (MaximumXYZ- MinimumXYZ).Y/4+j * Interval.Y/2, (MaximumXYZ- MinimumXYZ).Z/4+k * Interval.Z/2));
                         numVertices++;
                         Mapping.Add(new List<MappingFromNodesToT>());
                         C.Add(new List<int>());
                    }
                }
            }
            int index=0;
            for (int i = 0; i < XVertices-1; i++)
            {
                for (int j = 0; j < YVertices-1; j++)
                {
                    for (int k = 0; k < ZVertices-1; k++)
                    {
                        //
                        int index0 = i * YVertices * ZVertices + j * ZVertices + k;
                        int index1 = (i + 1) * YVertices * ZVertices + j * ZVertices + k;
                        int index2 = i * YVertices * ZVertices + (j + 1) * ZVertices + k;

                        int index3 = i * YVertices * ZVertices + j * ZVertices + (k + 1);

                        int index4 = (i + 1) * YVertices * ZVertices + (j + 1) * ZVertices + k;
                        int index5 = i * YVertices * ZVertices + (j + 1) * ZVertices + (k + 1);
                        int index6 = (i + 1) * YVertices * ZVertices + j * ZVertices + (k + 1);
                        int index7 = (i + 1) * YVertices * ZVertices + (j + 1) * ZVertices + (k + 1);

                        //Here we initilize 6 tetrahedrons from the cube. 
                        Vector3 Center= (NodesPosition[index0]+NodesPosition[index1]+NodesPosition[index2]+
                            NodesPosition[index3]+NodesPosition[index4]+NodesPosition[index5]+NodesPosition[index6]+
                            NodesPosition[index7])/8;
                        tetrahendra t0= new tetrahendra();
                        t0.id[0]= index0;
                        t0.id[1]= index1;
                        t0.id[2]= index2;
                        t0.id[3]= index3;
                        t0.UpdateElementMatrix(NodesPosition);
                        Mapping[index0].Add(new MappingFromNodesToT(index,0));
                        Mapping[index1].Add(new MappingFromNodesToT(index,1));
                        Mapping[index2].Add(new MappingFromNodesToT(index,2));
                        Mapping[index3].Add(new MappingFromNodesToT(index,3));
                        index++;

                        tetrahendra t1= new tetrahendra();

                        t1.id[0] = index2;
                        t1.id[1] = index3;
                        t1.id[2] = index5;
                        t1.id[3] = index7;
                        t1.UpdateElementMatrix(NodesPosition);
                        Mapping[index2].Add(new MappingFromNodesToT(index, 0));
                        Mapping[index3].Add(new MappingFromNodesToT(index, 1));
                        Mapping[index5].Add(new MappingFromNodesToT(index, 2));
                        Mapping[index7].Add(new MappingFromNodesToT(index, 3));
                        index++;


                        tetrahendra t2= new tetrahendra();

                        t2.id[0] = index1;
                        t2.id[1] = index3;
                        t2.id[2] = index6;
                        t2.id[3] = index7;
                        t2.UpdateElementMatrix(NodesPosition);
                        Mapping[index1].Add(new MappingFromNodesToT(index, 0));
                        Mapping[index3].Add(new MappingFromNodesToT(index, 1));
                        Mapping[index6].Add(new MappingFromNodesToT(index, 2));
                        Mapping[index7].Add(new MappingFromNodesToT(index, 3));
                        index++;
                        

                        tetrahendra t3= new tetrahendra();
                        t3.id[0] = index1;
                        t3.id[1] = index2;
                        t3.id[2] = index4;
                        t3.id[3] = index7;
                        t3.UpdateElementMatrix(NodesPosition);
                        Mapping[index1].Add(new MappingFromNodesToT(index, 0));
                        Mapping[index2].Add(new MappingFromNodesToT(index, 1));
                        Mapping[index4].Add(new MappingFromNodesToT(index, 2));
                        Mapping[index7].Add(new MappingFromNodesToT(index, 3));
                        index++;


                        tetrahendra t4= new tetrahendra();
                        t4.id[0] = index1;
                        t4.id[1] = index2;
                        t4.id[2] = index3;
                        t4.id[3] = index7;
                        t4.UpdateElementMatrix(NodesPosition);

                        Mapping[index1].Add(new MappingFromNodesToT(index, 0));
                        Mapping[index2].Add(new MappingFromNodesToT(index, 1));
                        Mapping[index3].Add(new MappingFromNodesToT(index, 2));
                        Mapping[index7].Add(new MappingFromNodesToT(index, 3));
                        index++;



                        Tetrahendrons.Add(t0);
                        Tetrahendrons.Add(t1);
                        Tetrahendrons.Add(t2);
                        Tetrahendrons.Add(t3);
                        Tetrahendrons.Add(t4);
                        
                    }
                }
            }
            
            
        }
        
    }
    class FEM
    {
        float[,] StiffnessMatrix;
        float[,] StiffnessMatrixInv;
        public float[] ElasticForces;
        public float[] DeltaU;
        public float[] Accumulate; 

        int NodesNum;
        public List<tetrahendra> tretrahendras;
      
        
        public void CreateStiffnessMatrix(int N, List<tetrahendra> ts)
        {
            NodesNum=N;
            ElasticForces = new float[3 * N];
            StiffnessMatrix = new float[3 * N, 3 * N];
            DeltaU=new float[3*N];
            Accumulate = new float[3 * N];
            //Firstly, initialize all zero
            for (int i = 0; i < 3 * N; i++)
            {
                for (int j = 0; j < 3 * N; j++)
                {

                    StiffnessMatrix[i,j] = 0.0f;
                }
                Accumulate[i]=0.0f;
            }
            
            for (int i = 0; i < 3*N; i++)
            {
                ElasticForces[i] = 0;
            }
                //Then Traverse all the tetrahedron 
                //Assembly get the Mesh Stiffness Matrix
            for(int i=0;i<ts.Count;i++)
            {
                rinv(ts[i].ElementStiffnessMatrix , 12);
            }
                for (int i = 0; i < ts.Count; i++)
                {

                    for (int j = 0; j < 4; j++)
                    {
                        for (int k = 0; k < 4; k++)
                        {

                            StiffnessMatrix[ts[i].id[j] * 3, ts[i].id[k] * 3] += ts[i].ElementStiffnessMatrix[j * 3 + 0, k * 3 + 0];
                            StiffnessMatrix[ts[i].id[j] * 3, ts[i].id[k] * 3 + 1] += ts[i].ElementStiffnessMatrix[j * 3 + 0, k * 3 + 1];
                            StiffnessMatrix[ts[i].id[j] * 3, ts[i].id[k] * 3 + 2] += ts[i].ElementStiffnessMatrix[j * 3 + 0, k * 3 + 2];
                            StiffnessMatrix[ts[i].id[j] * 3 + 1, ts[i].id[k] * 3] += ts[i].ElementStiffnessMatrix[j * 3 + 1, k * 3 + 0];
                            StiffnessMatrix[ts[i].id[j] * 3 + 1, ts[i].id[k] * 3 + 1] += ts[i].ElementStiffnessMatrix[j * 3 + 1, k * 3 + 1];
                            StiffnessMatrix[ts[i].id[j] * 3 + 1, ts[i].id[k] * 3 + 2] += ts[i].ElementStiffnessMatrix[j * 3 + 1, k * 3 + 2];
                            StiffnessMatrix[ts[i].id[j] * 3 + 2, ts[i].id[k] * 3] += ts[i].ElementStiffnessMatrix[j * 3 + 2, k * 3 + 0];
                            StiffnessMatrix[ts[i].id[j] * 3 + 2, ts[i].id[k] * 3 + 1] += ts[i].ElementStiffnessMatrix[j * 3 + 2, k * 3 + 1];
                            StiffnessMatrix[ts[i].id[j] * 3 + 2, ts[i].id[k] * 3 + 2] += ts[i].ElementStiffnessMatrix[j * 3 + 2, k * 3 + 2];
                        }
                    }
                }
            //Similarly we can get the inverse of the stiffnessMatrx;
            float[,] Inv=new float[3*N,3*N]; 
          
            for (int i = 0; i < 3 * N; i++)
            {
                for (int j = 0; j < 3 * N; j++)
                {
                    Inv[i,j]=StiffnessMatrix[i,j];
                }
            }
                rinv( Inv, 3 * N);
            StiffnessMatrixInv = Inv;


            float[,] sum = new float[3 * N, 3 * N];
            float sam=0.0f;
            for (int i = 0; i < 3 * N; i++)
            {
                for (int j = 0; j < 3 * N; j++)
                {
                    for (int k = 0; k < 3 * N; k++)
                    {
                        sam += StiffnessMatrix[i, k] * StiffnessMatrixInv[k, j];
                    }
                    sum[i, j] = sam;
                    sam = 0;
                }
            }
        }
        void BuildTetrahentraMesh(Face faces)
        { 

        }
        void CalculateElasticForce(List<tetrahendra> ts)
        {
            //for(int i=0;i<3*NodesNum;i++)
            //{
            //    float f=0.0f;
            //    for(int j=0;j<3*NodesNum;j++)
            //    {
            //        f+= StiffnessMatrix[i,j]*DeltaU[j];
            //    }
            //    ElasticForces[i]=f;
            //}
            float[] f=new float[12];
            float[] u = new float[12];

            for (int num = 0; num < ts.Count; num++)
            {
                float[] ue = new float[12];
              
                for (int i = 0; i < 4; i++)
                {

                    u[i * 3 + 0] = DeltaU[3 * ts[num].id[i]];
                    u[i * 3 + 1] = DeltaU[3 * ts[num].id[i] + 1];
                    u[i * 3 + 2] = DeltaU[3 * ts[num].id[i] + 2];
                }

                for (int i = 0; i < 3 * 4; i++)
                {
                    float s = 0.0f;
                    for (int j = 0; j < 3 * 4; j++)
                    {
                        s += ts[num].ElementStiffnessMatrix[i, j] * u[j];
                    }
                    f[i] = s;
                }
                for (int i = 0; i < 4; i++)
                {
                    ElasticForces[3 * ts[num].id[i]] = f[i * 3 + 0];
                    ElasticForces[3 * ts[num].id[i] + 1] = f[i * 3 + 1];
                    ElasticForces[3 * ts[num].id[i] + 2] = f[i * 3 + 2];
                }
            }



               
        }
        public static void rinv( float[,]  a, int n)
        {
            int[] rank = new int[n];
            int[] column = new int[n];
            int i, j, k;
            float temp, temp2, temp3;
            for (k = 0; k <= n - 1; k++)
            {
                temp = 0.0f;
                for (i = k; i <= n - 1; i++)
                    for (j = k; j <= n - 1; j++)
                    {
                        if (a[i, j] > temp)
                        {
                            temp = a[i, j];
                            rank[k] = i;
                            column[k] = j;
                        }
                    }
                if (temp + 1.0 == 1.0)
                {
                    Console.WriteLine("矩阵奇异");
                    break;
                }
                if (rank[k] != k)
                {
                    for (i = 0; i <= n - 1; i++)
                    {
                        temp2 = a[k, i];
                        a[k, i] = a[rank[k], i];
                        a[rank[k], i] = temp2;
                    }
                }
                if (column[k] != k)
                {
                    for (i = 0; i <= n - 1; i++)
                    {
                        temp2 = a[i, k];
                        a[i, k] = a[i, column[k]];
                        a[i, column[k]] = temp2;
                    }
                }
                a[k, k] = 1.0f / a[k, k];
                for (j = 0; j <= n - 1; j++)
                {
                    if (j != k)
                        a[k, j] = a[k, j] * a[k, k];
                }
                for (i = 0; i <= n - 1; i++)
                {
                    if (i != k)
                        for (j = 0; j <= n - 1; j++)
                            if (j != k)
                            {
                                a[i, j] = a[i, j] - a[i, k] * a[k, j];
                            }
                }
                for (i = 0; i <= n - 1; i++)
                    if (i != k)
                        a[i, k] = -a[i, k] * a[k, k];
            }

            for (k = n - 1; k >= 0; k--)
            {
                if (column[k] != k)
                    for (j = 0; j <= n - 1; j++)
                    {
                        temp3 = a[k, j];
                        a[k, j] = a[column[k], j];
                        a[column[k], j] = temp3;
                    }
                if (rank[k] != k)
                    for (i = 0; i <= n - 1; i++)
                    {
                        temp3 = a[i, k];
                        a[i, k] = a[i, rank[k]];
                        a[i, rank[k]] = temp3;
                    }
            }
        }
        public void Deformation(ref List<Vector3> NodesPosition,List<tetrahendra> ts)
        {
            
            //Update DeltaU and 
            for (int i = 0; i < 3 * NodesNum; i++)
            {
                if (Accumulate[i] >= 0.05f || Accumulate[i] <= -0.05f)
                {
                    DeltaU[i] = 0.0f;
                }
                       
            }
            CalculateElasticForce(ts);
          

            for (int i = 0; i < 3 * NodesNum; i++)
            {
                float u = 0.0f;
                for (int j = 0; j < 3 * NodesNum; j++)
                {
                    u += StiffnessMatrixInv[i, j] * ElasticForces[j];
                }
                DeltaU[i]= u;
                Accumulate[i] += DeltaU[i];
            }
          
           
            int index=0;
           
            for(int i=0;i<NodesPosition.Count;i++)
            {
                Vector3 dv = new Vector3();
                dv.X = DeltaU[index] ;
                index++;
                dv.Y = DeltaU[index] ;
                index++;
                dv.Z = DeltaU[index] ;
               
                index++;
                NodesPosition[i] +=dv;      
            }
        
            for (int i = 0; i < DeltaU.Length; i++)
            {
                //DeltaU[i] *= 0.0f;
            }
            for (int i = 0; i < ElasticForces.Length; i++)
            {
                //ElasticForces[i] *= 0.0f;
            }
            
        }
        
    }
}
