﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Diagnostics;
using System.ComponentModel;
using SlimDX;
using SlimDX.D3DCompiler;
using SlimDX.Direct3D11;
using SlimDX.DXGI;
namespace PhysicsEngine
{
    /// <summary>
    /// MainWindow.xaml 的交互逻辑
    /// </summary>
    public partial class MainWindow : Window
    {
        LittleBigTable.D3DImageSlimDX D3DImageContainer;
        LittleBigTable.SceneManager SceneMgr;
        LittleBigTable.SimulationStyle style;
        bool pause;
        float dt;
        public MainWindow()
        {
            Loaded += Window_Loaded;
            Closing += Window_Closing;
            InitializeComponent();
        }
        
        void Window_Loaded(object sender, RoutedEventArgs e)
        {
            D3DImageContainer = new LittleBigTable.D3DImageSlimDX();
            D3DImageContainer.IsFrontBufferAvailableChanged += OnIsFrontBufferAvailableChanged;

            //SlimDXImage.Width = 100;
            //SlimDXImage.Height = 100;

            SlimDXImage.Source = D3DImageContainer;

            pause = false;

            SceneMgr = new LittleBigTable.SceneManager(this, (int)SlimDXImage.Width, (int)SlimDXImage.Height);

            SlimDX.Direct3D11.Texture2D Texture = SceneMgr.GetDevice().SharedTexture;
            D3DImageContainer.SetBackBufferSlimDX(Texture);
            BeginRenderingScene();

        }
        void Window_Closing(object sender, CancelEventArgs e)
        {
            if (D3DImageContainer != null)
            {
                D3DImageContainer.Dispose();
                D3DImageContainer = null;

            }
        }

        void OnRendering(object sender, EventArgs e)
        {
            

            Point p = Mouse.GetPosition(SlimDXImage);
            SceneMgr.SetMousePosition((int)p.X, (int)p.Y);
            // Fuck.Content = "X" + p.X.ToString() + "Y" + p.Y.ToString() + "Status" + SceneMgr.GetDevice().GetMouseState().IsPressed(0).ToString();

            //double a = slider1.Value;

            //textBlock2.Text = "K value";
            //textBlock3.Text = slider2.Value.ToString() + "kg/s^2";

            //SceneMgr.SpringConstraint.Stiffness = (float)slider2.Value;

            //textBlock4.Text = "Mass value";
            //textBlock5.Text =slider3.Value.ToString()+"kg";

            //SceneMgr.SpringConstraint.Mass = (float)slider3.Value;
            //SceneMgr.SpringMass.Mass = (float)slider3.Value;
            //BulletInf.Text = "Bullet Position: " + "(" + SceneMgr.Bullet.Position.ToString() + ")" + "  Bullet Velocity" + "("+SceneMgr.Bullet.Velocity.ToString() +")"
            //    + "  Bullet Accelerate" + "(" + SceneMgr.Bullet.Accelerate.ToString() + ")";

            //SpringInf.Text = "SpringMass Position: " + "(" + SceneMgr.SpringMass.Position.ToString() + ")" + "  SpringMass Velocity" + "(" + SceneMgr.SpringMass.Velocity.ToString() + ")"
            //    + "  SpringMass Accelerate" + "(" + SceneMgr.SpringMass.Accelerate.ToString() + ")"; ; 
            //SceneMgr.SceneSimulationStyle = style;
            if (!pause)
            {
                if (SceneMgr.OnRendering == false)
                {
                    SceneMgr.Render(0.01f);
                  
                }
            }
          //  textBlock1.Text = ((float)a).ToString()+"s";
           
            D3DImageContainer.InvalidateD3DImage(SceneMgr);
           

            SceneMgr.Mass=(float)mass.Value;
            SceneMgr.Angle = (float)angle.Value;
            SceneMgr.Powder = (float)powder.Value;

            
        }

        void BeginRenderingScene()
        {
            if (D3DImageContainer.IsFrontBufferAvailable)
            {

             
                CompositionTarget.Rendering += OnRendering;
                

               // SlimDX.Direct3D11.Texture2D Texture = SceneMgr.GetDevice().SharedTexture;
                //D3DImageContainer.SetBackBufferSlimDX(Texture);

                //OnRendering();
             
               
            }
        }

        void StopRenderingScene()
        {

            CompositionTarget.Rendering -= OnRendering;
        }

        void OnIsFrontBufferAvailableChanged(object sender, DependencyPropertyChangedEventArgs e)
        {
            // This fires when the screensaver kicks in, the machine goes into sleep or hibernate
            // and any other catastrophic losses of the d3d device from WPF's point of view
            if (D3DImageContainer.IsFrontBufferAvailable)
            {
                BeginRenderingScene();
            }
            else
            {
                StopRenderingScene();
            }
        }

        private void SlimDXImage_ImageFailed(object sender, ExceptionRoutedEventArgs e)
        {

        }

        private void slider1_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {

        }

        private void button4_Click(object sender, RoutedEventArgs e)//Next time step
        {
           // pause = true;
            SceneMgr.Render((float)slider1.Value);
            
        }

       

        private void RK2Selected(object sender, RoutedEventArgs e)
        {
            style = LittleBigTable.SimulationStyle.RK2;
        }

        private void EulerSelected(object sender, RoutedEventArgs e)
        {
            style = LittleBigTable.SimulationStyle.Euler;
        }

        private void RK4Selected(object sender, RoutedEventArgs e)
        {
            style = LittleBigTable.SimulationStyle.RK4;
        }

        private void button3_Click(object sender, RoutedEventArgs e)//Restart
        {
            SceneMgr.ResetObjects();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            if (pause)
            {
                button1.Content = "Pause";
                pause = false;
            }
            else
            {
                button1.Content = "Start";
                pause = true;
            }
        }
    }
}
