﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace LittleBigTable
{
    using ArrayList= System.Collections.ArrayList;
    class DepthMapIndex
    {
        public float Depth;
        public int Index;
        public ShapeType Type;
    }
    public class ObjectSets
    {
        List<DepthMapIndex> indice;
        List<Object> objectRef;
        DepthMapIndex dmi;
        int ObjectCount;
        public ObjectSets()
        {
            objectRef = new List<Object>();
            indice = new List<DepthMapIndex>();
            ObjectCount = 0;
        }
        public int GetObjectCount()
        {

            return ObjectCount;
        }
        public Object GetObjectByIndex(int i)
        {
            int index = indice[i].Index;
            return objectRef[index];
        }

        public void AddObject(Object obj)
        {
            //Add object 
            // for (int i = 0; i < ObjectCount; i++)
            //{
            //    if (Math.Abs(objectRef[i].GetObjectDepth() - obj.GetObjectDepth())<0.1f)
            //    {
            //        obj.ObjInf.ObjectDepth -= 0.01f;
            //    }
            //}  
             objectRef.Add(obj);
           
            dmi=new DepthMapIndex();
            //Add indice data 
            dmi.Depth= -obj.GetObjectDepth();
           //dmi.Index= obj.GetIndex();
            indice.Add(dmi);
            ObjectCount++;
            UpdateIndex();
        }
        public void DeleteObject(Object item)
        {
            int i = 0;
            for (; i < ObjectCount; i++)
            {
                if (objectRef[i] == item)
                {
                    break;
                }
            }
            indice.Remove(indice[i]);
            objectRef.Remove(item);
            ObjectCount--;
            UpdateIndex();
        }
        public void RenderObjects(Shader shader, D3DDevice devices,Lighting lighting, Camera camera )
        {
            int index;
            for (int i = 0; i < ObjectCount; i++)
            {
                index = indice[i].Index;
               
                objectRef[index].Render(shader, devices.GetDevice(), lighting, camera,0.0f);
            }          
        }
        public void UpdateIndex()
        {
            for (int i = 0; i < ObjectCount; i++)
            {
                indice[i].Depth= -objectRef[i].GetObjectDepth();
                indice[i].Index = i;
            }
            QuickSort(ref indice, 0, ObjectCount - 1);
        }
        private void QuickSort(ref List<DepthMapIndex> objectRef, int first, int last)
        {
            if (last > first)
            {
                int pivotIndex = Partition(ref objectRef, first, last);
                QuickSort(ref objectRef, first, pivotIndex - 1);
                QuickSort(ref objectRef, pivotIndex + 1, last);
            }
        }
        private int Partition(ref List<DepthMapIndex> objects, int first, int last)
        {

            float pivot = objects[first].Depth; // Choose the first element as the pivot
            int low = first + 1; // Index for forward search
            int high = last; // Index for backward search
            while (high > low)
            {
                while (low <= high && objects[low].Depth <= pivot)
                    low++;
                while (low <= high && objects[high].Depth > pivot)
                    high--;
                if (high > low)
                {
                    //swap
                    DepthMapIndex temp = objects[high];
                    objects[high] = objects[low];
                    objects[low] = temp;
                }
            }
            while (high > first && objects[high].Depth >= pivot)
                high--;
            if (pivot > objects[high].Depth)
            {
                DepthMapIndex temp = objects[first];
                objects[first] = objects[high];
                objects[high] = temp;
                return high;
            }
            else
            {
                return first;
            }
        }

       
    }
}
